/*
   +----------------------------------------------------------------------+
   | PHP Version 5                                                        |
   +----------------------------------------------------------------------+
   | Copyright (c) 1997-2004 The PHP Group                                |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.0 of the PHP license,       |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_0.txt.                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Authors: Vijay Aswadhati <vijay@planetbazaar.com>                    |
   +----------------------------------------------------------------------+

   $Id: php_yami.h,v 1.1 2007/07/23 04:21:04 va Exp $ 
*/

#ifndef PHP_YAMI_H
#define PHP_YAMI_H

extern zend_module_entry yami_module_entry;
#define phpext_yami_ptr &yami_module_entry

#ifdef PHP_WIN32
#define PHP_YAMI_API __declspec(dllexport)
#else
#define PHP_YAMI_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

ZEND_BEGIN_MODULE_GLOBALS(yami)
    long default_response_timeout;
    long last_error;
ZEND_END_MODULE_GLOBALS(yami)

#ifdef ZTS
#define YAMI_G(v) TSRMG(yami_globals_id, zend_yami_globals *, v)
#else
#define YAMI_G(v) (yami_globals.v)
#endif

#define PHP_YAMI_EXT_VERSION "1.0"
#define PHP_YAMI_EXT_NAME "yami"

PHP_MINIT_FUNCTION(yami);
PHP_MSHUTDOWN_FUNCTION(yami);
PHP_RINIT_FUNCTION(yami);
PHP_RSHUTDOWN_FUNCTION(yami);
PHP_MINFO_FUNCTION(yami);

PHP_FUNCTION(yami_get_last_error);
PHP_FUNCTION(yami_get_error_string);
PHP_FUNCTION(yami_send_to);
PHP_FUNCTION(yami_get_default_policies);

PHP_FUNCTION(yami_agent_create);
PHP_FUNCTION(yami_agent_destroy);

PHP_FUNCTION(yami_agent_get_info);

PHP_FUNCTION(yami_agent_domain_register);
PHP_FUNCTION(yami_agent_domain_unregister);

PHP_FUNCTION(yami_agent_object_register);
PHP_FUNCTION(yami_agent_object_unregister);

/* outbound message */
PHP_FUNCTION(yami_agent_send);
PHP_FUNCTION(yami_agent_send_to);

PHP_FUNCTION(yami_message_setup_timeout);
PHP_FUNCTION(yami_message_wait);
PHP_FUNCTION(yami_message_get_response);

/* inbound message */
PHP_FUNCTION(yami_agent_receive);

PHP_FUNCTION(yami_message_consume);
PHP_FUNCTION(yami_message_reject);
PHP_FUNCTION(yami_message_reply);
PHP_FUNCTION(yami_message_forward);
PHP_FUNCTION(yami_message_forward_to);
PHP_FUNCTION(yami_message_get_request);

/* common to both outbound and inbound message */
PHP_FUNCTION(yami_message_destroy);
PHP_FUNCTION(yami_message_get_type);
PHP_FUNCTION(yami_message_get_info);
PHP_FUNCTION(yami_message_get_status);
PHP_FUNCTION(yami_message_get_status_string);

#endif
