<?php

echo "PHP YAMI Module Tests\n";

echo "\nDumping constants defined by the YAMI module\n";
echo "YAMI_OK = " . yami_get_error_string(YAMI_OK) . "\n";
echo "YAMI_BADHANDLE = " . yami_get_error_string(YAMI_BADHANDLE) . "\n";
echo "YAMI_OUTOFRANGE = " . yami_get_error_string(YAMI_OUTOFRANGE) . "\n";
echo "YAMI_CANNOTINITIALIZETWICE = " . yami_get_error_string(YAMI_CANNOTINITIALIZETWICE) . "\n";
echo "YAMI_BADTYPE = " . yami_get_error_string(YAMI_BADTYPE) . "\n";
echo "YAMI_NOTINITIALIZED = " . yami_get_error_string(YAMI_NOTINITIALIZED) . "\n";
echo "YAMI_ALREADYREGISTERED = " . yami_get_error_string(YAMI_ALREADYREGISTERED) . "\n";
echo "YAMI_NOTFOUND = " . yami_get_error_string(YAMI_NOTFOUND) . "\n";
echo "YAMI_QUEUEEMPTY = " . yami_get_error_string(YAMI_QUEUEEMPTY) . "\n";
echo "YAMI_PARSEERROR = " . yami_get_error_string(YAMI_PARSEERROR) . "\n";
echo "YAMI_CANNOTPROCESSTWICE = " . yami_get_error_string(YAMI_CANNOTPROCESSTWICE) . "\n";
echo "YAMI_BADLENGTH = " . yami_get_error_string(YAMI_BADLENGTH) . "\n";
echo "YAMI_NOSUCHSERVICE = " . yami_get_error_string(YAMI_NOSUCHSERVICE) . "\n";

echo "YAMI_NOTAVAILABLE = " . yami_get_error_string(YAMI_NOTAVAILABLE) . "\n";
echo "YAMI_NOMEMORY = " . yami_get_error_string(YAMI_NOMEMORY) . "\n";
echo "YAMI_CANNOTRESOLVEADDRESS = " . yami_get_error_string(YAMI_CANNOTRESOLVEADDRESS) . "\n";
echo "YAMI_BADADDRTYPE = " . yami_get_error_string(YAMI_BADADDRTYPE) . "\n";
echo "YAMI_CANNOTSTARTTHREAD = " . yami_get_error_string(YAMI_CANNOTSTARTTHREAD) . "\n";
echo "YAMI_THREADERROR = " . yami_get_error_string(YAMI_THREADERROR) . "\n";
echo "YAMI_SYNCHROERROR = " . yami_get_error_string(YAMI_SYNCHROERROR) . "\n";
echo "YAMI_NETERROR = " . yami_get_error_string(YAMI_NETERROR) . "\n";
echo "YAMI_OVERFLOW = " . yami_get_error_string(YAMI_OVERFLOW) . "\n";
echo "YAMI_INTERNAL = " . yami_get_error_string(YAMI_INTERNAL) . "\n";
echo "YAMI_NOHANDSHAKE = " . yami_get_error_string(YAMI_NOHANDSHAKE) . "\n";

echo "\n Dumping default YAMI policies\n";
$policies = yami_get_default_policies();
print_r($policies);
var_dump($policies);

echo "\nCalculator Server should be running at localhost on port 12340 for these tests to succeed.\n";
echo "\nCreating local agent using default policies as is...";
$agent = yami_agent_create(0, $policies);
if ( $agent != null ) {
	echo "... success\n";
	echo "Dumping agent brief agent information\n";
	$info = yami_agent_get_info($agent);
	print_r($info);

	echo "Dumping detailed agent information\n";
	$info = yami_agent_get_info($agent, true);
	print_r($info);	
		
	echo "Destroying local agent...";
	if ( yami_agent_destroy($agent) ) {
		echo "... success\n";
	}
	else {
		echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";	
	}
}
else {
	echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
}


echo "\nCreating local agent using modified policies (reuseaddr=true, sendtries=10) ...";
$policies["reuseaddr"] = true;
$policies["sendtries"] = 10;
$agent = yami_agent_create(0, $policies);
if ( $agent != null ) {
	echo "... success\n";
	echo "Dumping agent brief agent information\n";
	$info = yami_agent_get_info($agent);
	print_r($info);

	echo "Dumping detailed agent information\n";
	$info = yami_agent_get_info($agent, true);
	print_r($info);	
		
	echo "Destroying local agent...";
	if ( yami_agent_destroy($agent) ) {
		echo "... success\n";
	}
	else {
		echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";	
	}
}
else {
	echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
}

echo "\nCreating local agent again. This time to try domain registration and unregistration ...";
$agent = yami_agent_create();
if ( $agent != null ) {
	echo "... success\n";
	echo "Dumping detailed agent information\n";
	$info = yami_agent_get_info($agent, true);
	print_r($info);	
	
	echo "Registering domain (integra08, 12340, 2) as 'calculator ...'";
	if ( yami_agent_domain_register($agent, "calculator", "integra08", 12340) ) {
		echo "... success\n";
	}
	else {
		echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
	}

	echo "Registering polling object 'CalculatorAuditor' ...'";
	if ( yami_agent_object_register($agent, "CalculatorAuditor") ) {
		echo "... success\n";
	}
	else {
		echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
	}

	echo "Sending two way 'add' message to remote 'calculator'...'";
	$message = yami_agent_send($agent, "calculator", "calculator", "add", array(10000000, 1));
	if ( $message == null ) {
		echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
	}
	else {
		echo "... success\n";
		echo "setting up default timeout on the sent message to wait for reply....";
		if ( yami_message_setup_timeout($message) ) {
			echo "... success\n";
		}
		else {
			echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
		}
		
		echo "getting message status ...";
		$mstatus = yami_message_get_status($message);
		if ( $mstatus != -1 ) {
			echo "... success\n";
		}
		else {
			echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
		}
		
		echo "getting message status as string using return value of yami_message_get_status ...";
		$mstatus_string = yami_message_get_status_string($mstatus);
		if ( $mstatus != "bad error code" ) {
			echo "... success: $mstatus_string\n";
		}
		else {
			echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
		}

		echo "getting message status as string using message resource itself ...";
		$mstatus_string = yami_message_get_status_string($message);
		if ( $mstatus != "bad error code" ) {
			echo "... success: $mstatus_string\n";
		}
		else {
			echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
		}
		
		echo "Wating on message; should block (max) for default response timeout time if the server is working...";
		if ( yami_message_wait($message) ) {
			echo "... success: message status changed or timed out => " . yami_message_get_status_string($message) . "\n";
		}
		else {
			echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
		}
		
		echo "Obtaining response from remote servant...";
		$response = array(); 
		if ( yami_message_get_response($message, $response) ) {
			echo "... success: dumping response =>.\n";
			print_r($response);
		}
		else {
			echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
		}	
		
		echo "Deleting message created earlier...";
		if ( yami_message_destroy($message) ) {
			echo "... success.\n";
		}
		else {
			echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
		}	

		echo "Stress test on a deleted message...";
		$mstatus = yami_message_get_status($message);
		if ( $mstatus == -1 ) {
			echo "... success\n";
		}
		else {
			echo $mstatus;
			echo "... failed: message status should not have worked but got valid result " . yami_message_get_status_string($mstatus) . "\n";
		}		
	}
	
	echo "Unregistering polling object 'CalculatorAuditor' ...'";
	if ( yami_agent_object_unregister($agent, "CalculatorAuditor") ) {
		echo "... success\n";
	}
	else {
		echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
	}

	function CalculatorAuditorServant($message, $hint)
	{
		
	}
	
	echo "Registering passive object 'CalculatorAuditor' ...'";
	if ( yami_agent_object_register($agent, "CalculatorAuditor", CalculatorAuditorServant, "Foo" ) ) {
		echo "... success\n";
	}
	else {
		echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
	}

	echo "Unregistering passive object 'CalculatorAuditor' ...'";
	if ( yami_agent_object_unregister($agent, "CalculatorAuditor") ) {
		echo "... success\n";
	}
	else {
		echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
	}
	
		
	
	echo "Unregistering domain 'calculator' ...'";
	if ( yami_agent_domain_unregister($agent, "calculator") ) {
		echo "... success\n";
	}
	else {
		echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
	}
		
	echo "Destroying local agent...";
	if ( yami_agent_destroy($agent) ) {
		echo "... success\n";
	}
	else {
		echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
	}
}
else {
	echo "... failed: " . yami_get_error_string( yami_get_last_error() ) . "\n";
}




echo "\nSending quit message without reason - optional parameters not supplied. The server should not quit.\n";
if ( !yami_send_to("Integra08", 12340, "calculator", "quit") ) {
	echo yami_get_error_string( yami_get_last_error() );
}

echo "\nSending quit message with optional parameters set to null. The server should not quit.\n";
if ( !yami_send_to("Integra08", 12340, "calculator", "quit", null) ) {
	echo yami_get_error_string( yami_get_last_error() );
}

echo "\nSending quit message with reason. The server should quit.\n";
if ( !yami_send_to("Integra08", 12340, "calculator", "quit", array("boring stuff")) ) {
	echo yami_get_error_string( yami_get_last_error() );
}
?>
