/*
 * yamidomains.h
 *
 * this is an implementation of the domain set
 * (agent's address book)
 *
 * Copyright (C) 2001-2005 Maciej Sobczak
 * http://www.msobczak.com/prog/yami/
 *
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 *
 */

#ifndef YAMIDOMAINS_INCLUDED
#define YAMIDOMAINS_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef void* HDOMAINS;

int yamiCreateDomainSet     (HDOMAINS *pds, int synchro);
int yamiDestroyDomainSet    (HDOMAINS ds);
int yamiDomainSetRegister   (HDOMAINS ds, const char *name, const char *addr,
                             int port, int level, int options);
int yamiDomainSetUnregister (HDOMAINS ds, const char *name);
int yamiDomainSetLookUp     (HDOMAINS ds, const char *name, int *ipaddr,
                             int *port, int *level, int *options);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
