/*
 * yamiqueue.h
 *
 * this is an implementation of the queue used between threads
 *
 * Copyright (C) 2001-2005 Maciej Sobczak
 * http://www.msobczak.com/prog/yami/
 *
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 *
 */

#ifndef YAMIQUEUE_INCLUDED
#define YAMIQUEUE_INCLUDED

#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef void* HQUEUE;

int yamiCreateQueue   (HQUEUE *pq, size_t maxlength, size_t maxsize,
                       int synchro);
int yamiDestroyQueue  (HQUEUE q);
int yamiQueuePushBack (HQUEUE q, void *data1, void *data2, size_t size);
int yamiQueuePopFront (HQUEUE q, void **data1, void **data2, size_t *size);
int yamiQueueIsEmpty  (HQUEUE q);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
