/*
 * yamierrors.h
 *
 * error codes
 *
 * Copyright (C) 2001-2005 Maciej Sobczak
 * http://www.msobczak.com/prog/yami/
 *
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 *
 */

#ifndef YAMIERRORS_INCLUDED
#define YAMIERRORS_INCLUDED

#define YAMIOK                    0

#define YAMILOGICERROR            ((int)0x40100000)
#define YAMIRUNTIMEERROR          ((int)0x40010000)

#define YAMIISLOGICERROR(e)       ((e & YAMILOGICERROR) == YAMILOGICERROR)
#define YAMIISRUNTIMEERROR(e)     ((e & YAMIRUNTIMEERROR) == YAMIRUNTIMEERROR)

#define YAMIBADHANDLE             ((int)(YAMILOGICERROR   | 0x01))
#define YAMIOUTOFRANGE            ((int)(YAMILOGICERROR   | 0x02))
#define YAMICANNOTINITIALIZETWICE ((int)(YAMILOGICERROR   | 0x03))
#define YAMIBADTYPE               ((int)(YAMILOGICERROR   | 0x04))
#define YAMINOTINITIALIZED        ((int)(YAMILOGICERROR   | 0x05))
#define YAMIALREADYREGISTERED     ((int)(YAMILOGICERROR   | 0x06))
#define YAMINOTFOUND              ((int)(YAMILOGICERROR   | 0x07))
#define YAMIQUEUEEMPTY            ((int)(YAMILOGICERROR   | 0x08))
#define YAMIPARSEERROR            ((int)(YAMILOGICERROR   | 0x09))
#define YAMICANNOTPROCESSTWICE    ((int)(YAMILOGICERROR   | 0x0a))
#define YAMIBADLENGTH             ((int)(YAMILOGICERROR   | 0x0b))
#define YAMINOSUCHSERVICE         ((int)(YAMILOGICERROR   | 0x0c))

#define YAMINOTAVAILABLE          ((int)(YAMIRUNTIMEERROR | 0x01))
#define YAMINOMEMORY              ((int)(YAMIRUNTIMEERROR | 0x02))
#define YAMICANNOTRESOLVEADDRESS  ((int)(YAMIRUNTIMEERROR | 0x03))
#define YAMIBADADDRTYPE           ((int)(YAMIRUNTIMEERROR | 0x04))
#define YAMICANNOTSTARTTHREAD     ((int)(YAMIRUNTIMEERROR | 0x05))
#define YAMITHREADERROR           ((int)(YAMIRUNTIMEERROR | 0x06))
#define YAMISYNCHROERROR          ((int)(YAMIRUNTIMEERROR | 0x07))
#define YAMINETERROR              ((int)(YAMIRUNTIMEERROR | 0x08))
#define YAMIOVERFLOW              ((int)(YAMIRUNTIMEERROR | 0x09))
#define YAMIINTERNAL              ((int)(YAMIRUNTIMEERROR | 0x0a))
#define YAMINOHANDSHAKE           ((int)(YAMIRUNTIMEERROR | 0x0b))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* returns a pointer to human-readable error description */
/* returns NULL if the code is unknown                   */
/* can be useful as a debugging help                     */
const char * yamiErrorString(int cc);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
